# $Id: composefrommods.py 2964 2010-01-25 13:29:53Z  place $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/trunk/sources/meresco/bzv/src/composefrommods.py $

from meresco.core import Observable
import re

class ComposeFromMods(Observable):
    def __init__(self, infra, fieldName ):
        Observable.__init__(self)
        self.infra = infra
        
        normalisationConfig = self.infra.configRoot
        if fieldName == 'norm.genre':
            self._normDict = normalisationConfig.getSectionNormalized('genre')
            self._xpath = '//mods:mods/mods:genre/text()'
        elif fieldName == 'norm.language':
            self._normDict = normalisationConfig.getSectionNormalized('languages')
            self._xpath = '//mods:mods/mods:language/mods:languageTerm/text()'
        self._namespaceMap = {'mods':'http://www.loc.gov/mods/v3'}
        self._fieldName = fieldName

    def addXml(self, lxmlNode):
        logger = self.infra.logger
#        logger.warning(self.infra.prpt('normDict', self._normDict))
        items = lxmlNode.xpath(self._xpath, self._namespaceMap)
        value = ""
        
        for item in items:
            try:
                item = item.rstrip('/')
                value = self._normDict[item]
                yield self.all.addField(name=self._fieldName, value=value)
            except KeyError:
                logger.warning( 'No value found for code: "' + item +'"' )
                pass
        if not value: yield self.all.addField(name=self._fieldName, value="unknown")
        
